-- Default localization - enUS
local ADDON_NAME = "GearGrinder";

local L = LibStub("AceLocale-3.0"):NewLocale(ADDON_NAME, "enUS", true);

L.core = {
	menuText = "Gear Grinder %s",
	versionText = "|cff00aa00%s|r",
	buttonLabel = "GearGrinder",
	buttonText = "%s %s",
	tooltip = "Gear Grinder",
	cooldownInfoText = "Resets:",
	cooldownInfoLastText = "Last Reset:",
	cooldownInfoNextText = "Next Reset:",
	cooldownInfoDay = "days",
	cooldownInfoHr = "hrs",
	cooldownInfoMin = "min",
	PDCharTextShort = "Characters",
	PDiLvlTextShort = "iLvl",
	PDVPText = "Valor Points",
	PDVPTextShort = "Valor",
	PDVPTooltip = "The amount of Valor Points your character currently has.",
	PDVPTooltipMax = "The maximum allowed is %s.",
	PDVPCapText = "Valor Progress",
	PDVPCapTextShort = "VP Cap",
	PDVPCapTooltip = "The number of Valor points earnt this week.",
	PDVPCapTooltipMax = "The weekly earning cap is %s.",
	PDJPText = "Justice Points",
	PDJPTextShort = "Justice",
	PDJPTooltip = "The amount of Justice Points your character currently has.",
	PDJPTooltipMax = "The maximum allowed is %s.",
	PDCharmText = "Lesser/Elder Charms",
	PDCharmTextShort = "Bonus",
	PDActivityText = "Daily/Weekly Activities",
	PDActivityTextShort = "Activity",
	PDHPTextShort = "Honor",
	PDCPTextShort = "Conquest",
	PDCPCapTextShort = "CP Cap",
	PDProfCDTextShort = "Profs",
	PDTimelessTextShort = "Timeless",
	PDiELvlTextShort = "E iLvl",
	
	desc = "Records the Valor and Justice Point cap progress for all characters on the realm",
	name = "Gear Grinder",
    load = "Loading Gear Grinder |cff00aa00v%s|r by Azadan",
	
	BossTitle = "Bosses",
	BossGalleon = "Galleon",
	BossGalleonShort = "Galleon",
	BossShaOfAnger = "Sha of Anger",
	BossShaOfAngerShort = "Sha",
	BossOondasta = "Oondasta",
	BossOondastaShort = "Oondasta",
	BossNalak = "Nalak, the Storm Lord",
	BossNalakShort = "Nalak",
	BossCelestial = "The August Celestials",
	BossCelestialShort = "Celestial",
	BossOrdos = "Ordos, Fire-God of the Yaungol",
	BossOrdosShort = "Ordos",
	BossLooted = "Dead",
	BossNotLooted = "Alive",
	
	LFRTitle = "Raids",
	LFR_MV = "MV",
	LFR_HoF = "HoF",
	LFR_ToES = "ToES",
	LFR_ToT = "ToT",
	LFR_SoO = "SoO",
	LFR_SoOFlex = "Flex",
	
	ProfAlcText = "Alc",
	ProfBSText = "BS",
	ProfBS2Text = "BI",
	ProfEnchText = "Ench",
	ProfScribeText = "Ins",
	ProfTailorText = "IS",
	ProfTailor2Text = "CC",
	ProfLWText = "MH",
	ProfLW2Text = "HMH",
	ProfJCGemText = "Gem",
	ProfJCHeartText = "Hrt",
	ProfEngText = "Eng",
	
	options = {
		name = "Gear Grinder Options",
		options = "General Options",
		minimap = "Show Minimap Button",
		minimapDesc = "Toggles showing the minimap button",
		dailyResetHour = "Daily Reset Hour",
		dailyResetHourDesc = "The hour of the day when the Daily Quests are reset.",
		resetHour = "Weekly Reset Hour",
		resetHourDesc = "The hour of the day when the weekly Valor Point Cap is reset.",
		resetDayOfWeek = "Weekly Reset Day",
		resetDayOfWeekDesc = "The day of the week when the weekly Valor Point Cap is reset.",
		combat = "Show In-combat?",
		combatDesc = "Show the tooltip whilst in combat?",
		filtering = "Enable filtering?",
		filteringDesc = "Toggle to enable/disable character filtering.",
		scale = "Set the Tooltip UI Scale",
		scaleDesc = "Tooltip UI scaling factor for the Tooltip. Default = 1.",
		paperdollVP = "Show Valor on Stats",
		paperdollVPDesc = "Shows your Valor Points on the Character Info window on the stats pane.",
		paperdollVPCap = "Show Progress on Stats",
		paperdollVPCapDesc = "Shows your Valor Points Cap Progress on the Character Info window on the stats pane.",
		paperdollJP = "Show Justice on Stats",
		paperdollJPDesc = "Shows your Justice Points on the Character Info window on the stats pane.",
		purge = "Erase Saved Details",
		purgeDesc = "Erase all the saved details for all characters.",
		ldb = "LDB Options",
		ldbText = "LDB Text",
		ldbTextDesc = "Toggle LDB on and off, this will save a little resources.",
		ldbTextColor = "LDB Text Colorize?",
		ldbTextColorDesc = "Toggle to turn on/off the changing colors of the text.",
		ldbSource = "LDB Source Label",
		ldbSourceDesc = "Show a label of the source data for the LDB Button.",
		ldbDisplay = "Button Text",
		ldbDisplayDesc = "Selection of the text to display on the LDB Button",
		ldbDisplayLock = "Lock the Button Text?",
		ldbDisplayLockDesc = "Toggle the locking of the LDB Button Text from being changed when being left-clicked.",
		optionDesc = "Open VP Cap Progress Options UI",
		
		-- activities.
		ActivityEH = "Empowering the Hourglass quest  |cffA335EE200VP  |cff00FF00EH|r",
		ActivityPM = "Path of the Mistwalker quest  |cffA335EE50VP  |cff00FF00PM|r",
		ActivityH = "Random Heroic Dungeon  |cffA335EE80VP  |cff00FF00H|r",
		ActivityHS = "Random Heroic Scenario  |cffA335EE120VP  |cff00FF00HS|r",
		ActivityS = "Random Scenario  |cffA335EE50VP  |cff00FF00S|r",
		ActivityC = "Challenge Mode Dungeon quest  |cffA335EE60VP  |cff00FF00C|r",
		ActivityCoTK = "Champion of the Thunder King quest  |cffA335EE150VP  |cff00FF00CTK|r",
		ActivityTom = "Tomb \"Tom\" Bone Apart Spirit Chests |cffA335EE40-120VP each |cff00FF00Tom|r",
		
		sortOrder = "Sort Order",
		sortOrderDesc = "Selection of the Sort Order of the entries",
		boss = "Show World Bosses?",
		bossDesc = "Toggle to show/hide the World Boss kill status",
		showIcon = "Show Icons?",
		showIconDesc = "Toggle to show/hide the Icons.", 

		-- toon section
		TooniELevel = "Equipped Item Level",
		TooniLevel = "Maximum Item Level",
		ToonVPCap = "Valor Point Cap",
		ToonVP = "Valor Points",
		ToonJP = "Justice Points",
		ToonHP = "Honor Points",
		ToonCP = "Conquest Points",
		ToonCPCap = "Conquest Point Cap",
		ToonCharm = "Bonus Roll Tokens",
		ToonProfCD = "Profession Cooldowns",
		ToonFarm = "Sunsong Ranch Farming",
		ToonActivity = "Activities",
				
		-- Raid 
		raid = "Show Raid Details?",
		raidDesc = "Toggle to show/hide the Raid Details.", 
		LFR = "Show Raid Details?",
		LFRDesc = "Toggle to show/hide the Raid Details.", 
		LFRNormal = "Show Normal/Heroic difficulty raid saves?",
		LFRNormalDesc = "Toggle to show/hide the Normal/Heroic difficulty raid saves.", 
		LFRFlex = "Show Flex difficulty raid saves?",
		LFRFlexDesc = "Toggle to show/hide the Flexible Raid difficulty raid saves.", 
		
		-- Headings
		ttContent = "Tooltip Contents",
		ttActivity = "Activities Display",
		ttProfs = "Profession Cooldowns Display",
		ttRaids = "Raid Display",
		ttBoss = "World Boss Display",
		
		-- Professions
		ProfAlc = "Alchemy : |cff1EFF00Transmute: Living Steel |cff00FF00(Alc)|r",
		ProfBS = "Blacksmithing : |cff0070DDLightning Steel Ingot |cff00FF00(BS)|r",
		ProfBS2 = "Blacksmithing : |cff0070DDBalanced Trillium Ingot |cff00FF00(BI)|r",
		ProfTailor = "Tailoring : |cff0070DDImperial Silk |cff00FF00(IS)|r",
		ProfTailor2 = "Tailoring : |cff0070DDCelestial Cloth |cff00FF00(CC)|r",
		ProfEnch = "Enchanting : |cffA335EESha Crystal |cff00FF00(Ench)|r",
		ProfScribe = "Inscription : |cff0070DDScroll of Wisdom |cff00FF00(Ins)|r",
		ProfJCGem = "Jewelcrafting : Various crafts to create a |cff0070DDFacets of Research |cff00FF00(Gem)|r",
		ProfJCHeart = "Jewelcrafting : |cff0070DDSerpent's Heart |cff00FF00(Hrt)|r",
		ProfLW = "Leatherworking : Various crafts to create a |cff0070DDMagnificent Hide |cff00FF00(MH)|r",
		ProfLW2 = "Leatherworking : |cff0070DDHardened Magnificent Hide |cff00FF00(HMH)|r",
		ProfEng = "Engineering : |cff0070DDJard's Peculiar Energy Source |cff00FF00(Eng)|r",
		
	}
}


